--
-- $Id: mkhref.hs,v 1.16 2005/12/03 14:34:57 aamine Exp $
--
-- Copyright (c) 2003-2005 Minero Aoki
--
-- This program is free software.
-- You can distribute/modify this program under the terms of
-- the GNU LGPL, Lesser General Public License version 2.1.
-- For details of the GNU LPGL, see the file "COPYING".
--

module Main (main) where

import HrefDatabase
import PathUtils (basename)
import Utils

import System (getArgs)
import Data.Char (isSpace)

main = do prefix <- myGetEnv hrefDataDirEnv
          ents <- (return . concat) =<< mapM (loadModule) =<< getArgs
          mapM_ (putEntry prefix) ents
          putIndex prefix ents

loadModule :: FilePath -> IO [Entry]
loadModule path = return . parseModule (basename path) =<< readFile path

parseModule :: String -> String -> [Entry]
parseModule mod = map (chunkToEntry mod) . chunks . lines

chunkToEntry :: String -> String -> Entry
chunkToEntry mod cs = Entry (EntrySpec mod (funcname cs)) cs
  where
    funcname cs = case (head . words . head . lines) cs of
                    w@('(':_) -> tail (init w)
                    w         -> w

chunks :: [String] -> [String]
chunks [] = []
chunks ss = unlines (header ++ body) : chunks ss'
  where
    (header, cont) = break (isSpace.headChar) ss
    (body, ss') = break (not.isSpace.headChar) cont

    headChar "" = ' '
    headChar (x:xs) = x
